Is Regression: No
Sprint Focus:
Subject: Invalid localization overlay of cObject FILES
Description
The TypoScript cObject FILES does not consider localization overlays and behavior correctly:
    -  l10n_mode is not considered
    -  additional translation table (e.g. for pages) is not considered correctly

Related issues:
related to Core - Bug # 57488: page record overlays: media field not translat... Resolved 2014-04-01
related to Core - Bug # 47869: Failed localization of FILES content object re... Resolved 2013-05-03
related to Core - Bug # 48113: typoscript FILES object always uses default la... Resolved 2013-05-11
related to Core - Bug # 57272: Extbase doesn't handle FAL translations correctly Under Review 2014-03-25
related to Core - Bug # 59192: mergeIfNotBlank with FAL records Accepted 2014-05-28
related to Core - Bug # 60998: PageRepository::shouldFieldBeOverlaid raises P... Resolved 2014-08-15
related to Core - Bug # 65863: content_fallback / mergeIfNotblank fails with ... Under Review 2015-03-20

Associated revisions
Revision d976053c - 2014-06-11 16:54 - Oliver Hader

[BUGFIX] Invalid localization overlay of cObject FILES

The TypoScript cObject FILES does not consider localization
overlays and behavior correctly when it comes additional
translation table (e.g. for pages).

Concerning pages_language_overlay.media, there is no default
fallback to the values of the default language. This behavior
is the same to TYPO3 4.5. If the localization shall fallback
to the default language, the "mergeIfNotBlank" property needs
to be used for the accordant field.

For having the localization handling working properly the
FILES cObject section "references" must not set the properties
"table" and "uid" - otherwise the values will just be overriden
by those TypoScript settings.

Resolves: #58352
Resolves: #47869
Releases: 6.2
Change-Id: I8e915654e5ab1ed1eafe86411930f9fbfcc225ae
Reviewed-on: https://review.typo3.org/29739
Reviewed-by: Steffen Ritter
Tested-by: Steffen Ritter

Revision 90b0b4a3 - 2014-06-11 22:41 - Steffen Ritter

[BUGFIX] FollowUp to "Invalid localization overlay of cObject FILES"

When fixing language overlay of cObject FILES, the mocking in the unit
test was not adapted.

Resolves: #58352
Resolves: #47869
Releases: 6.2
Change-Id: I8f939e31a13e437e437624dfccddf5f39526fb8b
Reviewed-on: https://review.typo3.org/30666
Reviewed-by: Helmut Hummel
Tested-by: Helmut Hummel

History
#1 - 2014-04-30 11:14 - Gerrit Code Review
- Status changed from New to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#2 - 2014-05-03 12:52 - Oliver Hader

How to test the patch:
Requirements:
    -  open typo3conf/extTables.php and put

$GLOBALS['TCA']['pages_language_overlay']['columns']['media']['l10n_mode'] = 'mergeIfNotBlank';
    -  clear TCA caches (e.g. "clear all" in Install Tool)
    -  create translation of a page, without translating the media field (on the resources tab)
    -  have some TypoScript to out the file or the name of the file, e.g.

@page = PAGE
page.10 = FILES

        1. page.10.references = ...
page.10.renderObj = TEXT
page.10.renderObj.data = file:current:publicUrl
page.10.renderObj.wrap = |,

Tests:
1) TypoScript using the special "fieldName" property
page.10.references.fieldName = media

2) TypoScript using stdWrap
page.10.references.field = media

#3 - 2014-05-03 18:37 - Frans Saris
@Olly:
This doesn't work:

page.10.references.field = media

In handleFileReferences() you explicit look for fieldName or else there is a early return.

#4 - 2014-05-03 19:30 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#5 - 2014-05-03 20:16 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#6 - 2014-05-04 14:11 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#7 - 2014-05-04 14:16 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#8 - 2014-05-04 15:51 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#9 - 2014-05-08 14:35 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#10 - 2014-06-11 16:54 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/29739

#11 - 2014-06-11 17:10 - Tymoteusz Motylewski
should be resolved with https://review.typo3.org/29739

#12 - 2014-06-11 17:11 - Steffen Ritter
- Status changed from Under Review to Resolved

#13 - 2014-06-11 17:50 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30666

#14 - 2014-06-11 19:49 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30666

#15 - 2014-06-11 22:39 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/30666

#16 - 2014-06-11 23:30 - Steffen Ritter
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:90b0b4a3973697c2324c5a7ef8eec7db0a23d66e.
